 /* ==================================================================================================================
 *
 *  ݒEBhEvV[W
 *
 ================================================================================================================== */


#include "UltraRC4Plugin.h"
#include <time.h>



// bZ[W֐^
typedef BOOL (*MSG_FUNC)(HWND, WPARAM, LPARAM, LRESULT*);
// bZ[W֐\
typedef struct {
	UINT     msg_id;
	MSG_FUNC msg_func;
} MSG_TABLE, *LPMSG_TABLE;
// Rg[֐^
typedef BOOL (*CTRL_FUNC)(HWND, HWND, WORD, WORD, LRESULT*);
// Rg[֐\
typedef struct {
	UINT      ctrl_id;
	CTRL_FUNC ctrl_func;
} CTRL_TABLE, *LPCTRL_TABLE;




// vg^Cv
static BOOL WINAPI WndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
static BOOL OnCommand(HWND hwnd, WPARAM wp, LPARAM lp, LRESULT* pResult);





/* ------------------------------------------------------------------------------------------------------
	EBhE쐬
------------------------------------------------------------------------------------------------------ */
int ShowConfigDialog(HINSTANCE hInstance, HWND hOwner, LPARAM lParam)
{
	return (int)DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DLGCONFIG), hOwner, WndProc, lParam);
}










///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//               ebZ[W֐
//


/* ------------------------------------------------------------------------------------------------------
	WM_CLOSE
------------------------------------------------------------------------------------------------------ */
static BOOL OnClose(HWND hwnd, WPARAM wp, LPARAM lp, LRESULT* pResult)
{
	EndDialog(hwnd, lp);
	return FALSE;
}

/* ------------------------------------------------------------------------------------------------------
	WM_INITDIALOG
------------------------------------------------------------------------------------------------------ */
static BOOL OnCreate(HWND hwnd, WPARAM wp, LPARAM lp, LRESULT* pResult)
{
	SetWindowText(hwnd, (LPCSTR)lp);
	SetDlgItemText(hwnd, IDC_FILENAME, URC4KEY);
	ShowWindow(hwnd, SW_SHOW);
	return TRUE;
}

/* ------------------------------------------------------------------------------------------------------
	WM_NOTIFY
------------------------------------------------------------------------------------------------------ */
static BOOL OnNotify(HWND hwnd, WPARAM wp, LPARAM lp, LRESULT* pResult)
{
	return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//               eRg[֐
//


/* ------------------------------------------------------------------------------------------------------
	IDOK
------------------------------------------------------------------------------------------------------ */
static BOOL OnOK(HWND hwnd, HWND hCtrl, WORD wID, WORD wNotify, LRESULT* pResult)
{
	char szKeyFile[MAX_PATH]="";

	GetDlgItemText(hwnd, IDC_FILENAME, szKeyFile, sizeof(szKeyFile));
	if( szKeyFile[0]=='\0' )
	{
		MessageBox(hwnd, "Please input filename.", NULL, MB_ICONERROR);
		return TRUE;
	}

	// t@C
	FILE* fp = fopen(URC4KEY, "wb");
	if( !fp )
	{
		MessageBox(hwnd, "File open error.", NULL, MB_ICONERROR);
		return TRUE;
	}

	srand( clock() );
	for(int i=0; i < URC4KEYLEN; i++)
	{
		BYTE data = (BYTE)(rand() & 0xff);
		fwrite(&data, sizeof(BYTE), 1, fp);
	}

	fclose( fp );
	return TRUE;
}

/* ------------------------------------------------------------------------------------------------------
	IDCANCEL
------------------------------------------------------------------------------------------------------ */
static BOOL OnCancel(HWND hwnd, HWND hCtrl, WORD wID, WORD wNotify, LRESULT* pResult)
{
	SendMessage(hwnd, WM_CLOSE, 0, 0);
	return TRUE;
}





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//             bZ[Wnhe[u`
//
//
static const MSG_TABLE msg_handler[] = {
	{WM_CLOSE           , OnClose},
	{WM_INITDIALOG      , OnCreate},
	{WM_NOTIFY          , OnNotify},
	{WM_COMMAND         , OnCommand},
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//             Rg[nhe[u`
//
static const CTRL_TABLE ctrl_handler[] = {
	{IDOK               , OnOK},
	{IDCANCEL           , OnCancel},
};

/* ------------------------------------------------------------------------------------------------------
	CEBhEv[W
------------------------------------------------------------------------------------------------------ */
static BOOL WINAPI WndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	LRESULT result=TRUE;
	static const int table_max = sizeof(msg_handler) / sizeof(msg_handler[0]);

	for(int i=0; i < table_max; i++)
	{
		if( msg_handler[i].msg_id == msg )
		{
			if( msg_handler[i].msg_func &&
				msg_handler[i].msg_func(hwnd, wp, lp, &result) )
				return (BOOL)result;
			break;
		}
	}
	return FALSE;
}

/* ------------------------------------------------------------------------------------------------------
	WM_COMMAND
------------------------------------------------------------------------------------------------------ */
static BOOL OnCommand(HWND hwnd, WPARAM wp, LPARAM lp, LRESULT* pResult)
{
	UINT ctrl = LOWORD(wp);

	static const int table_max = sizeof(ctrl_handler) / sizeof(ctrl_handler[0]);

	// Rg[nh
	for(int i=0; i < table_max; i++)
	{
		// Rg[֐
		if( ctrl_handler[i].ctrl_id == ctrl &&
			ctrl_handler[i].ctrl_func )
			return ctrl_handler[i].ctrl_func(hwnd, (HWND)lp, LOWORD(wp), HIWORD(wp), pResult);
	}
	return FALSE;
}
