/*
 * An implementation of the ARC4 algorithm,
 * by Christophe Devine <devine@cr0.net>;
 * this program is licensed under the GPL.
 */

#include "librc4.h"


/* -------------------------------------------------------------------------------------------
	f[^̐
------------------------------------------------------------------------------------------- */
void rc4_setup(RC4STATE* s, const uint8* key, int length)
{
    int j=0;
	int k=0;
	int a=0;

	// \̂
    s->x = 0;
    s->y = 0;
    uint8* m = s->m;

	// obt@
    for(int i = 0; i < 256; i++) m[i] = i;

	// ް쐬
    for(int i = 0; i < 256; i++ )
	{
        a = m[i];
        j = ( j + a + key[k] ) & 0xff;
        m[i] = m[j];
		m[j] = a;
        ( ++k >= length ) ? k = 0 : 0;	// pX[h𒴂擪
    }
}

/* -------------------------------------------------------------------------------------------
	Í
------------------------------------------------------------------------------------------- */
void rc4_crypt(RC4STATE *s, const uint8* src, int length, uint8* dest)
{ 
    int a=0;
	int b=0;

	// l擾
    int  x = s->x;
    int  y = s->y;
    uint8* m = s->m;

    for(int i=0; i < length; i++)
	{
        x = ( x + 1 ) & 0xff;
		a = m[x];
        y = ( y + a ) & 0xff;
        m[x] = b = m[y];
        m[y] = a;
        dest[i] = src[i] ^ m[ (a+b)&0xff ];
    }

    s->x = x;
    s->y = y;
}

