/*
 * An implementation of the ARC4 algorithm,
 * by Christophe Devine <devine@cr0.net>;
 * this program is licensed under the GPL.
 */

#ifndef _LIBRC4_H_
#define _LIBRC4_H_

typedef unsigned long	uint32;
typedef unsigned char	uint8;

// \
typedef struct
{
    int x;
	int y;
	uint8 m[256];
} RC4STATE, *LPRC4STATE;

void rc4_setup(RC4STATE* s, const uint8* key, int length);
void rc4_crypt(RC4STATE *s, const uint8* src, int length, uint8* dest);

#endif // _LIBRC4_H_
